/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPODOCU                                                 */
/* Tabela : TIPODOCU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 21/04/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPODOCU
BEFORE INSERT OR UPDATE OR DELETE
ON TIPODOCU FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTDOC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPODOCU,0) <> NVL(:NEW.CDTIPODOCU,0)) OR
         (NVL(:OLD.NMTIPODOCU,0) <> NVL(:NEW.NMTIPODOCU,0)) THEN
         :NEW.DTULTATUTDOC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPODOCU', '', 'CDTIPODOCU='||:OLD.CDTIPODOCU||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPODOCU MODIFY DTULTATUTDOC DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPODOCU','4.11.134'); END;
/
