/*+
|                                               |
|     Trigger: DTULTATU_ENDEVENDE               |  
|     Tabela : ENDEVENDE                        |
|                                               |
|     Criao:                                  |
|     23/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_ENDEVENDE
BEFORE INSERT OR UPDATE OR DELETE
ON ENDEVENDE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUENVE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF ((NVL(:OLD.IDTPENDEVEN,  0) <> NVL(:NEW.IDTPENDEVEN, 0)) OR
           (NVL(:OLD.DSENDEVEN,   0) <> NVL(:NEW.DSENDEVEN,   0)) OR
           (NVL(:OLD.NMBAIRVEN,   0) <> NVL(:NEW.NMBAIRVEN,   0)) OR
           (NVL(:OLD.NRCEPVEN,    0) <> NVL(:NEW.NRCEPVEN,    0)) OR
           (NVL(:OLD.NRTELEVEN,   0) <> NVL(:NEW.NRTELEVEN,   0)) OR
           (NVL(:OLD.NRRAMALVEN,  0) <> NVL(:NEW.NRRAMALVEN,  0)) OR
           (NVL(:OLD.NRTELEXVEN,  0) <> NVL(:NEW.NRTELEXVEN,  0)) OR          
           (NVL(:OLD.NRFAXVEN,    0) <> NVL(:NEW.NRFAXVEN,    0)) OR
           (NVL(:OLD.NMCONTVEN,   0) <> NVL(:NEW.NMCONTVEN,   0)) OR
           (NVL(:OLD.DSEMAILVEN,  0) <> NVL(:NEW.DSEMAILVEN,  0)) OR
           (NVL(:OLD.CDPAIS,      0) <> NVL(:NEW.CDPAIS,      0)) OR
           (NVL(:OLD.SGESTADO,    0) <> NVL(:NEW.SGESTADO,    0)) OR
           (NVL(:OLD.CDMUNICIPIO, 0) <> NVL(:NEW.CDMUNICIPIO, 0)) OR
           (NVL(:OLD.CDVENDEDOR,  0) <> NVL(:NEW.CDVENDEDOR,  0)) OR
           (NVL(:OLD.CDBAIRRO,    0) <> NVL(:NEW.CDBAIRRO,    0)) OR
           (NVL(:OLD.NRCELULARVEN,0) <> NVL(:NEW.NRCELULARVEN,0)) OR
           (NVL(:OLD.NRTELRESIVEN,0) <> NVL(:NEW.NRTELRESIVEN,0))) THEN
           :NEW.DTULTATUENVE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
      VALUES ('ENDEVENDE'  , '', 'IDTPENDEVEN='||:OLD.IDTPENDEVEN||'CDVENDEDOR='||:OLD.CDVENDEDOR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ENDEVENDE MODIFY DTULTATUENVE DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ENDEVENDE','4.11.160'); END;
/

